package com.ti.msp430.iec60730.configTool;

import java.awt.event.ActionEvent;
import java.io.File;
import java.io.FileFilter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.regex.Pattern;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JInternalFrame;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 *
 * @author a0272979
 */

public class Iec60730ConfigUI extends javax.swing.JFrame {
	
	// The following class is used to save all GUI component information
	public class GuiInformation{
		boolean wdtflag;
		boolean jumpToFailSafe;
		int timertype;
		int ccrValue;
		int clkType;
		int mainClkFreq;
		int mainClkDiv;
		int aclkFrequency;
		int aclkDivider;
		int percentFrequency;
		String ramStartAddress;
		String ramSize;
		String stackSize;
		int ramEndAddress;
		int marchTestType;
		boolean destructive;
		int ramTestBuffer;
		String crcSeed;
		String checkSumLocation;
		int minADCDrift;
		int maxADCDrift;
		HashMap<String, String> testCodes = new HashMap<String, String>();
		
		public String getRamSize() {
			return ramSize;
		}
		public String getStackSize() {
			return stackSize;
		}
		public void setRamStartAddress(String ramStartAddress) {
			this.ramStartAddress = ramStartAddress;
		}
		public void setRamSize(String ramSize) {
			this.ramSize = ramSize;
		}
		public void setStackSize(String stackSize) {
			this.stackSize = stackSize;
		}
		public HashMap<String, String> getTestCodes() {
			return testCodes;
		}
		public void setTestCodes(HashMap<String, String> testCodes) {
			this.testCodes = testCodes;
		}
		public int getAclkDivider() {
			return aclkDivider;
		}
		public void setAclkDivider(int aclkDivider) {
			this.aclkDivider = aclkDivider;
		}
		public boolean isWdtflag() {
			return wdtflag;
		}
		public void setWdtflag(boolean wdtflag) {
			this.wdtflag = wdtflag;
		}
		public boolean isJumpToFailSafe() {
			return jumpToFailSafe;
		}
		public void setJumpToFailSafe(boolean jumpToFailSafe) {
			this.jumpToFailSafe = jumpToFailSafe;
		}
		public int getTimertype() {
			return timertype;
		}
		public void setTimertype(int timertype) {
			this.timertype = timertype;
		}
		public void setCcrValue(int ccrValue) {
			this.ccrValue = ccrValue;
		}
		public int getCcrValue() {
			return ccrValue;
		}
		public int getClkType() {
			return clkType;
		}
		public void setClkType(int clkType) {
			this.clkType = clkType;
		}
		public int getMainClkFreq() {
			return mainClkFreq;
		}
		public void setMainClkFreq(int mainClkFreq) {
			this.mainClkFreq = mainClkFreq;
		}
		public int getMainClkDiv() {
			return mainClkDiv;
		}
		public void setMainClkDiv(int mainClkDiv) {
			this.mainClkDiv = mainClkDiv;
		}
		public int getAclkFrequency() {
			return aclkFrequency;
		}
		public void setAclkFrequency(int aclkFrequency) {
			this.aclkFrequency = aclkFrequency;
		}
		public int getPercentFrequency() {
			return percentFrequency;
		}
		public void setPercentFrequency(int percentFrequency) {
			this.percentFrequency = percentFrequency;
		}
		public String getRamStartAddress() {
			return ramStartAddress;
		}
		public int getRamEndAddress() {
			return ramEndAddress;
		}
		public void setRamEndAddress(int ramEndAddress) {
			this.ramEndAddress = ramEndAddress;
		}
		public int getMarchTestType() {
			return marchTestType;
		}
		public void setMarchTestType(int marchTestType) {
			this.marchTestType = marchTestType;
		}
		public boolean isDestructive() {
			return destructive;
		}
		public void setDestructive(boolean destructive) {
			this.destructive = destructive;
		}
		public int getRamTestBuffer() {
			return ramTestBuffer;
		}
		public void setRamTestBuffer(int ramTestBuffer) {
			this.ramTestBuffer = ramTestBuffer;
		}
		public String getCrcSeed() {
			return crcSeed;
		}
		public void setCrcSeed(String crcSeed) {
			this.crcSeed = crcSeed;
		}
		public String getCheckSumLocation() {
			return checkSumLocation;
		}
		public void setCheckSumLocation(String checkSumLocation) {
			this.checkSumLocation = checkSumLocation;
		}
		public int getMinADCDrift() {
			return minADCDrift;
		}
		public void setMinADCDrift(int minADCDrift) {
			this.minADCDrift = minADCDrift;
		}
		public int getMaxADCDrift() {
			return maxADCDrift;
		}
		public void setMaxADCDrift(int maxADCDrift) {
			this.maxADCDrift = maxADCDrift;
		}	
	}

    /**
     * Creates new form Iec60730ConfigUI
     * @param args 
     */
    public Iec60730ConfigUI(String[] args) {
        initComponents(args);
    }

    @SuppressWarnings("unchecked")
    private void initComponents(String[] args) {
    	
        jPanel1 = new javax.swing.JPanel();
        jTextField1 = new javax.swing.JTextField();
        jCheckBox1 = new javax.swing.JCheckBox();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jCheckBox2 = new javax.swing.JCheckBox();
        jCheckBox3 = new javax.swing.JCheckBox();
        jPanel3 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jSpinner1 = new javax.swing.JSpinner();
        jSpinner2 = new javax.swing.JSpinner();
        jLabel32 = new javax.swing.JLabel();
        jLabel33 = new javax.swing.JLabel();
        jLabel36 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jTextField3 = new javax.swing.JTextField();
        jTextField4 = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jRadioButton1 = new javax.swing.JRadioButton();
        jRadioButton2 = new javax.swing.JRadioButton();
        jCheckBox4 = new javax.swing.JCheckBox();
        jLabel7 = new javax.swing.JLabel();
        jSpinner3 = new javax.swing.JSpinner();
        jLabel8 = new javax.swing.JLabel();
        jPanel5 = new javax.swing.JPanel();
        jCheckBox5 = new javax.swing.JCheckBox();
        jLabel9 = new javax.swing.JLabel();
        jTextField5 = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        jTextField6 = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        jTextField7 = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        jTextField8 = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        jTextField9 = new javax.swing.JTextField();
        jTextField10 = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        jTextField11 = new javax.swing.JTextField();
        jLabel15 = new javax.swing.JLabel();
        jTextField12 = new javax.swing.JTextField();
        jLabel16 = new javax.swing.JLabel();
        jLabel17 = new javax.swing.JLabel();
        jTextField13 = new javax.swing.JTextField();
        jPanel6 = new javax.swing.JPanel();
        jComboBox1 = new javax.swing.JComboBox();
        jLabel18 = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        jComboBox2 = new javax.swing.JComboBox();
        jLabel20 = new javax.swing.JLabel();
        jComboBox3 = new javax.swing.JComboBox();
        jTextField14 = new javax.swing.JTextField();
        jLabel21 = new javax.swing.JLabel();
        jLabel22 = new javax.swing.JLabel();
        jComboBox4 = new javax.swing.JComboBox();
        jPanel7 = new javax.swing.JPanel();
        jLabel23 = new javax.swing.JLabel();
        jComboBox5 = new javax.swing.JComboBox();
        jTextField15 = new javax.swing.JTextField();
        jLabel24 = new javax.swing.JLabel();
        jLabel25 = new javax.swing.JLabel();
        jComboBox6 = new javax.swing.JComboBox();
        jLabel26 = new javax.swing.JLabel();
        jSpinner4 = new javax.swing.JSpinner();
        jPanel8 = new javax.swing.JPanel();
        jLabel28 = new javax.swing.JLabel();
        jTextField16 = new javax.swing.JTextField();
        jLabel29 = new javax.swing.JLabel();
        jTextField17 = new javax.swing.JTextField();
        jPanel9 = new javax.swing.JPanel();
        jTextField18 = new javax.swing.JTextField();
        jButton3 = new javax.swing.JButton();
        jCheckBox6 = new javax.swing.JCheckBox();
        jCheckBox7 = new javax.swing.JCheckBox();
        jCheckBox8 = new javax.swing.JCheckBox();
        jCheckBox9 = new javax.swing.JCheckBox();
        jTextField19 = new javax.swing.JTextField();
        jButton4 = new javax.swing.JButton();
        jTextField20 = new javax.swing.JTextField();
        jButton5 = new javax.swing.JButton();
        jTextField21 = new javax.swing.JTextField();
        jButton6 = new javax.swing.JButton();
        jButton7 = new javax.swing.JButton();
        jPanel10 = new javax.swing.JPanel();
        jCheckBox10 = new javax.swing.JCheckBox();
        jLabel34 = new javax.swing.JLabel();
        jComboBox7 = new javax.swing.JComboBox();
        jTextField26 = new javax.swing.JTextField();
        jLabel35 = new javax.swing.JLabel();
        jButton8 = new javax.swing.JButton();
        jButton9 = new javax.swing.JButton();
        jLabel30 = new javax.swing.JLabel();
        jTextField22 = new javax.swing.JTextField();
        jLabel31 = new javax.swing.JLabel();
        jTextField23 = new javax.swing.JTextField();
        jLabel37 = new javax.swing.JLabel();
        jTextField24 = new javax.swing.JTextField();
        jLabel38 = new javax.swing.JLabel();
        jTextField25 = new javax.swing.JTextField();
        mainMenuBar = new javax.swing.JMenuBar();
        mainMenu = new javax.swing.JMenu();
        fileMenuItem = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("MSP430 IEC60730 Software Package Configuration Tool");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setResizable(false);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "MSP430 IEC60730 Software Package Path", javax.swing.border.TitledBorder.LEFT, javax.swing.border.TitledBorder.DEFAULT_POSITION));

        // Set the default directory path to output the header file to {IEC60730_ROOT}/iec60730/include.
        // This assumes the tool is run from {IEC60730_ROOT}/utils
        File headerLocation=null;
		try {
			if(args.length==0){
				headerLocation = new File("./../iec60730/include").getCanonicalFile();
			}else{
				headerLocation = new File(args[1]).getCanonicalFile();
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        jTextField1.setText(headerLocation.getAbsolutePath());
        jTextField1.setEnabled(false);

        
        // Allows the user to modify the output path of the header file in case the tool is not
        // run from default path
        jCheckBox1.setText("Use Default Location");
        jCheckBox1.setSelected(true);
        jCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox1ActionPerformed(evt);
            }
        });

        // Open File Dialog in Directory mode
        jButton1.setText("Browse...");
        jButton1.setEnabled(false);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        // Generate Button in MSP430 IEC60730 Software Package Path Panel
        jButton2.setText("Generate");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        
        // Layout definition for "MSP430 IEC60730 Software Package Path Panel"
        // Layout used absolute positioning of the components
        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jCheckBox1)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 797, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 99, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 99, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jCheckBox1)
                    .addComponent(jButton2))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        // JPanel2 contains Basic Configuration Option:
        // -Watchdog enabled
        // -JUMP_TO_FAILSAFE option
        
        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Basic Configuration"));

        jCheckBox2.setSelected(true);
        jCheckBox2.setText("Watchdog Timer will be enabled");
        jCheckBox2.setToolTipText("Select if application requires self-test to feed Watchdog Timer during execution.");
        jCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox2ActionPerformed(evt);
            }
        });

        jCheckBox3.setText("Define JUMP_TO_FAILSAFE macro");
        jCheckBox3.setSelected(true);
        jCheckBox3.setToolTipText("Select to define JUMP_TO_FAILSAFE macro in application.");

        // Layout definition for "Basic Configuration" Panel
        // Layout used absolute positioning of the components
        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jCheckBox2)
                    .addComponent(jCheckBox3))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(jCheckBox2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jCheckBox3))
        );

        // JPanel3 contains ADC Test Properties
        // Panel to set the ADC Count Drfit values. It is configured to accept only positive and negative integer
        // values.
        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "ADC Test Properties"));

        jLabel1.setText("MINIMUM ADC");
        jLabel1.setToolTipText("MUST be a negative value");

        jSpinner1.setModel(new javax.swing.SpinnerNumberModel(-50, -512, 0, 1));

        jSpinner2.setModel(new javax.swing.SpinnerNumberModel(50, 0, 512, 1));

        jLabel32.setText(" Count Drift");

        jLabel33.setText("MAXIMUM ADC");
        jLabel33.setToolTipText("MUST be a negative value");

        jLabel36.setText(" Count Drift");

        // Layout definition for "ADC Test Properties" Panel
        // Layout used absolute positioning of the components
        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(jSpinner1)
                        .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(jLabel32, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel36, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel33, javax.swing.GroupLayout.PREFERRED_SIZE, 85, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jSpinner2, javax.swing.GroupLayout.PREFERRED_SIZE, 63, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(40, 40, 40))
        );

        jPanel3Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jLabel1, jLabel32, jSpinner1});

        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jLabel33))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel32)
                    .addComponent(jLabel36))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jSpinner1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jSpinner2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(0, 18, Short.MAX_VALUE))
        );

        // JPanel4 contains properties for RAM test:
        // -RAM start address
        // -RAM size
        // -STACK size
        // -Type of MARCH algorithm
        // -Definition of DESTRUCTIVE or NON-DESTRUCTIVE mode 
        
        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "RAM Test Properties"));

        jLabel3.setText("RAM start address:");
        
        jTextField2.setText("0x0000");

        jLabel4.setText("RAM size:");
        
        jTextField3.setText("0x0000");

        jLabel5.setText("STACK size:");
        
        jTextField4.setText("80");

        jLabel6.setText("Select type of MARCH algorithm to test RAM memory:");

        jRadioButton1.setText("MARCH_C");
        jRadioButton1.setSelected(false);
        jRadioButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton1ActionPerformed(evt);
            }
        });

        jRadioButton2.setText("MARCH_X");
        jRadioButton2.setSelected(true);
        jRadioButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton2ActionPerformed(evt);
            }
        });

        jCheckBox4.setSelected(true);
        jCheckBox4.setText("Run RAM test in NON-DESTRUCTIVE MODE");
        jCheckBox4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox4ActionPerformed(evt);
            }
        });

        jLabel7.setText("Enter size of RAM_SAFE_BUFFER:");

        jSpinner3.setModel(new javax.swing.SpinnerNumberModel(Integer.valueOf(16), Integer.valueOf(0), null, Integer.valueOf(2)));

        jLabel8.setText("Bytes");

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap(31, Short.MAX_VALUE)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel4Layout.createSequentialGroup()
                            .addComponent(jLabel3)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addComponent(jLabel6, javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel4Layout.createSequentialGroup()
                            .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(jLabel4)
                                .addComponent(jLabel5))
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addComponent(jTextField4, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jTextField3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jRadioButton1)
                        .addGap(65, 65, 65)
                        .addComponent(jRadioButton2))
                    .addComponent(jCheckBox4)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jLabel7)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jSpinner3, javax.swing.GroupLayout.PREFERRED_SIZE, 63, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel8))))
        );

        jPanel4Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jTextField2, jTextField3, jTextField4});

        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(jTextField3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(jTextField4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel6)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton1)
                    .addComponent(jRadioButton2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jCheckBox4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel7)
                    .addComponent(jSpinner3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel8))
                .addContainerGap(60, Short.MAX_VALUE))
        );

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Test Codes"));

        jCheckBox5.setSelected(true);
        jCheckBox5.setText("Use DEFAULT Test Code");
        jCheckBox5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox5ActionPerformed(evt);
            }
        });

        jLabel9.setText("CPU Test Pass:");
        jLabel9.setToolTipText("(SIG_CPU_REG_TEST)");
        jLabel9.setEnabled(false);

        jTextField5.setEditable(false);
        jTextField5.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        jTextField5.setText("0xCC");
        jTextField5.setEnabled(false);
        jTextField5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField5ActionPerformed(evt);
            }
        });

        jLabel10.setText("PC Test Pass:");
        jLabel10.setToolTipText("(SIG_PC_REG_TEST)");
        jLabel10.setEnabled(false);

        jTextField6.setEditable(false);
        jTextField6.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        jTextField6.setText("0xCD");
        jTextField6.setEnabled(false);

        jLabel11.setText("MCLK Test Pass:");
        jLabel11.setToolTipText("(SIG_CLOCK_TEST)");
        jLabel11.setEnabled(false);

        jTextField7.setEditable(false);
        jTextField7.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        jTextField7.setText("0xCE");
        jTextField7.setEnabled(false);

        jLabel12.setText("RAM Test Pass:");
        jLabel12.setToolTipText("(SIG_RAM_TEST)");
        jLabel12.setEnabled(false);

        jTextField8.setEditable(false);
        jTextField8.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        jTextField8.setText("0xCF");
        jTextField8.setEnabled(false);

        jLabel13.setText("Non-Volatile Memory Test Pass:");
        jLabel13.setToolTipText("(SIG_NV_MEM_CRC_TEST )");
        jLabel13.setEnabled(false);

        jTextField9.setEditable(false);
        jTextField9.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        jTextField9.setText("0xD0");
        jTextField9.setEnabled(false);

        jTextField10.setEditable(false);
        jTextField10.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        jTextField10.setText("0xD1");
        jTextField10.setEnabled(false);

        jLabel14.setText("ADC Test Pass:");
        jLabel14.setToolTipText("(SIG_ADC_TEST)");
        jLabel14.setEnabled(false);

        jTextField11.setEditable(false);
        jTextField11.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        jTextField11.setText("0xD2");
        jTextField11.setEnabled(false);

        jLabel15.setText("GPIO Test Pass:");
        jLabel15.setToolTipText("(SIG_GPIO_TEST)");
        jLabel15.setEnabled(false);

        jTextField12.setEditable(false);
        jTextField12.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        jTextField12.setText("0xD3");
        jTextField12.setToolTipText("");
        jTextField12.setEnabled(false);

        jLabel16.setText("INTERRUPT Test Pass:");
        jLabel16.setToolTipText("(SIG_INTERRUPT_TEST)");
        jLabel16.setEnabled(false);

        jLabel17.setText("Test Failure (TEST_FAILURE):");
        jLabel17.setToolTipText("(TEST_FAILURE)");
        jLabel17.setEnabled(false);

        jTextField13.setEditable(false);
        jTextField13.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        jTextField13.setText("0x00");
        jTextField13.setEnabled(false);

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel10)
                            .addComponent(jLabel11)
                            .addComponent(jLabel12)
                            .addComponent(jLabel13)
                            .addComponent(jLabel14)
                            .addComponent(jLabel15)
                            .addComponent(jLabel16)
                            .addComponent(jLabel17))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jTextField8, javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jTextField9, javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jTextField10, javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jTextField11, javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jTextField12, javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jTextField13, javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jTextField6, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 59, Short.MAX_VALUE)
                            .addComponent(jTextField7, javax.swing.GroupLayout.Alignment.TRAILING)))
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addComponent(jCheckBox5)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel5Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jTextField10, jTextField11, jTextField12, jTextField13, jTextField6, jTextField7, jTextField8, jTextField9});

        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jCheckBox5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTextField6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel10, javax.swing.GroupLayout.Alignment.TRAILING))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel11)
                    .addComponent(jTextField7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(10, 10, 10)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel12)
                    .addComponent(jTextField8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel13)
                    .addComponent(jTextField9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(13, 13, 13)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel14)
                    .addComponent(jTextField10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel15)
                    .addComponent(jTextField11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel16)
                    .addComponent(jTextField12, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel17)
                    .addComponent(jTextField13, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        
        jPanel6.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Clock Test Properties"));

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "TIMER_A0", "TIMER_A1", "TIMER_A2" }));

        jLabel18.setText("Select TIMER_A for MCLK test:");

        jLabel19.setText("SelectCapture/Compare Register:");

        jComboBox2.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "CCR0", "CCR1", "CCR2", "CCR3", "CCR4" }));

        jLabel20.setText("Select MCLK Frequency:");

        jTextField14.setFont(new java.awt.Font("Tahoma", 0, 11)); 
        jTextField14.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        jTextField14.setText("12000000");

        jLabel21.setFont(new java.awt.Font("Tahoma", 0, 11));
        jLabel21.setText("Hz");
        jLabel21.setEnabled(false);

        jLabel22.setText("Select MCLK Frequency Divider:");

        jComboBox4.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "1", "2", "4", "8", "16", "32" }));
        jComboBox4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox4ActionPerformed(evt);
            }

        });

        jPanel7.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "External ACLK Properties"));

        jLabel23.setText("External Clock Frequency:");

        jTextField15.setEditable(true);
        jTextField15.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        jTextField15.setText("32768");
        jTextField15.setEnabled(true);

        jLabel24.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        jLabel24.setText("Hz");
        jLabel24.setEnabled(false);

        jLabel25.setText("Select MCLK Frequency Divider:");

        jComboBox6.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "1", "2", "4", "8", "16", "32" }));

        javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel7Layout.createSequentialGroup()
                        .addComponent(jLabel23)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextField15, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel24, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel7Layout.createSequentialGroup()
                        .addComponent(jLabel25)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jComboBox6, javax.swing.GroupLayout.PREFERRED_SIZE, 81, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel23)
                    .addComponent(jLabel24)
                    .addComponent(jTextField15, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel25)
                    .addComponent(jComboBox6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(50, Short.MAX_VALUE))
        );

        jLabel26.setText("Frequency Drift Tolerance (%): +/-");

        jSpinner4.setModel(new javax.swing.SpinnerNumberModel(3, 0, 100, 1));

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addComponent(jLabel20)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextField14, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel21, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel26)
                            .addComponent(jLabel22)
                            .addComponent(jLabel18)
                            .addComponent(jLabel19))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jComboBox4, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jComboBox1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jComboBox2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jSpinner4, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 6, Short.MAX_VALUE)
                .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(37, 37, 37))
        );

        jPanel6Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jComboBox1, jComboBox2, jComboBox4, jSpinner4});

        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel6Layout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel20)
                            .addComponent(jLabel21)
                            .addComponent(jTextField14, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel22)
                            .addComponent(jComboBox4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel18)
                            .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel19)
                            .addComponent(jComboBox2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel26)
                            .addComponent(jSpinner4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(31, Short.MAX_VALUE))
        );

        jPanel8.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "CRC-CCITT Test Properties"));

        jLabel28.setText("CRC Initial Value:");

        jTextField16.setText("0xFFFF");

        jLabel29.setText("CRC checksum location:");
        
        jTextField17.setText("0x1000");

        jPanel9.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "CRC-CCITT Checksum Generator"));

        jTextField18.setEditable(false);
        jTextField18.setEnabled(false);

        jButton3.setText("Browse...");
        jButton3.setEnabled(false);
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jCheckBox6.setText("Load Memory File #1");
        
        jCheckBox6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox6ActionPerformed(evt);
            }
        });

        jCheckBox7.setText("Load Memory File #2");
        jCheckBox7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox7ActionPerformed(evt);
            }
        });

        jCheckBox8.setText("Load Memory File #3");
        jCheckBox8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox8ActionPerformed(evt);
            }
        });

        jCheckBox9.setText("Load Memory File #4");
        jCheckBox9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox9ActionPerformed(evt);
            }
        });

        jTextField19.setEditable(false);
        jTextField19.setEnabled(false);
        
        jButton4.setText("Browse...");
        jButton4.setEnabled(false);
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jTextField20.setEditable(false);
        jTextField20.setEnabled(false);

        jButton5.setText("Browse...");
        jButton5.setEnabled(false);
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        jTextField21.setEditable(false);
        jTextField21.setEnabled(false);

        jButton6.setText("Browse...");
        jButton6.setEnabled(false);
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });

        jButton7.setText("Calculate");
        jButton7.setEnabled(false);
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });

        jPanel10.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Memory File Generation"));
        jPanel10.setEnabled(false);

        jCheckBox10.setText("Generate File with CRC check sums");
        jCheckBox10.setEnabled(false);
        jCheckBox10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox10ActionPerformed(evt);
            }
        });

        jLabel34.setText("Select Output format of Memory File:");
        jLabel34.setEnabled(false);

        jComboBox7.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "*.dat", "*.txt" }));
        jComboBox7.setEnabled(false);

        jTextField26.setEnabled(false);

        jLabel35.setText("Specify location to output memory file:");
        jLabel35.setEnabled(false);

        jButton8.setText("Browse...");
        jButton8.setEnabled(false);
        jButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton8ActionPerformed(evt);
            }
        });

        jButton9.setText("Create");
        jButton9.setEnabled(false);
        jButton9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton9ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel10Layout = new javax.swing.GroupLayout(jPanel10);
        jPanel10.setLayout(jPanel10Layout);
        jPanel10Layout.setHorizontalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel10Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jCheckBox10)
                    .addComponent(jLabel35)
                    .addGroup(jPanel10Layout.createSequentialGroup()
                        .addComponent(jTextField26, javax.swing.GroupLayout.PREFERRED_SIZE, 206, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jButton8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jButton9, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel10Layout.createSequentialGroup()
                        .addComponent(jLabel34)
                        .addGap(18, 18, 18)
                        .addComponent(jComboBox7, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(1, 1, 1)))
                .addContainerGap(30, Short.MAX_VALUE))
        );
        jPanel10Layout.setVerticalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel10Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jCheckBox10)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel34)
                    .addComponent(jComboBox7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel35)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField26, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton8))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton9)
                .addGap(0, 12, Short.MAX_VALUE))
        );

        jLabel30.setText("File #1 checksum:");

        jLabel31.setText("File #2 checksum:");

        jLabel37.setText("File #3 checksum:");

        jLabel38.setText("File #4 checksum:");

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel9Layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addComponent(jCheckBox6))
                    .addGroup(jPanel9Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jCheckBox9)
                            .addGroup(jPanel9Layout.createSequentialGroup()
                                .addComponent(jTextField20, javax.swing.GroupLayout.PREFERRED_SIZE, 221, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButton5)))))
                .addGap(0, 0, Short.MAX_VALUE))
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
                        .addGap(0, 4, Short.MAX_VALUE)
                        .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel9Layout.createSequentialGroup()
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel9Layout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addComponent(jCheckBox8))
                            .addGroup(jPanel9Layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(jTextField19, javax.swing.GroupLayout.PREFERRED_SIZE, 221, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel9Layout.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel9Layout.createSequentialGroup()
                                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jTextField18, javax.swing.GroupLayout.PREFERRED_SIZE, 221, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(jCheckBox7))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jButton3))
                                    .addGroup(jPanel9Layout.createSequentialGroup()
                                        .addComponent(jTextField21, javax.swing.GroupLayout.PREFERRED_SIZE, 221, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jButton6))))
                            .addGroup(jPanel9Layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(jLabel30)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextField22, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel31)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextField23, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel9Layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(jLabel37)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextField24, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel38)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextField25, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel9Layout.createSequentialGroup()
                                .addGap(118, 118, 118)
                                .addComponent(jButton7)))
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );

        jPanel9Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jButton3, jButton4, jButton5, jButton6});

        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addGap(6, 6, 6)
                .addComponent(jCheckBox6)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField18, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jCheckBox7)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField19, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jCheckBox8)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField20, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jCheckBox9)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField21, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton6))
                .addGap(10, 10, 10)
                .addComponent(jButton7)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel30)
                    .addComponent(jTextField22, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel31)
                    .addComponent(jTextField23, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel37)
                    .addComponent(jTextField24, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel38)
                    .addComponent(jTextField25, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(jPanel10, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel8Layout = new javax.swing.GroupLayout(jPanel8);
        jPanel8.setLayout(jPanel8Layout);
        jPanel8Layout.setHorizontalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel8Layout.createSequentialGroup()
                        .addComponent(jLabel28)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jTextField16, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel29)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextField17, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel8Layout.setVerticalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel28)
                    .addComponent(jTextField16, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel29)
                    .addComponent(jTextField17, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        mainMenu.setText("File");

        fileMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F4, java.awt.event.InputEvent.ALT_MASK));
        fileMenuItem.setText("Exit");
        mainMenu.add(fileMenuItem);

        mainMenuBar.add(mainMenu);

        setJMenuBar(mainMenuBar);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jPanel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                            .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jPanel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }

    
	private void jRadioButton1ActionPerformed(ActionEvent evt) {
		if(jRadioButton1.isSelected()){
			jRadioButton2.setSelected(false);
		}else{
			jRadioButton2.setSelected(true);
		}
		
	}
	private void jRadioButton2ActionPerformed(ActionEvent evt) {
		if(jRadioButton2.isSelected()){
			jRadioButton1.setSelected(false);
		}else{
			jRadioButton1.setSelected(true);
		}
		
	}
    private void jTextField5ActionPerformed(ActionEvent evt) {
		// TODO Auto-generated method stub
		
	}
    
    private void jCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {                                           
    	if(jCheckBox1.isSelected()){
    		jTextField1.setEditable(false);
    		jTextField1.setEnabled(false);
    		jButton1.setEnabled(false);
    		File headerLocation=null;
    		try {
    			headerLocation = new File("./../iec60730/include").getCanonicalFile();
    		} catch (IOException e) {
    			e.printStackTrace();
    		}
            jTextField1.setText(headerLocation.getAbsolutePath());
    		
    	}else{
    		jTextField1.setEditable(true);
    		jTextField1.setEnabled(true);
    		jButton1.setEnabled(true);
    	}
    }                                          

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {                                         
        setDirectoryPath("Header File Directory", jTextField1);
    }    
    
    private void jButton2ActionPerformed(ActionEvent evt) {
    	String headerPath = jTextField1.getText()+"/IEC60730_user_config_custom.h";
    	
	    	GuiInformation guiInfo = new GuiInformation();
	    	
	    	if(obtainGuiInfoForHeader(guiInfo)){
	    		if(generateApproved("Do you want to generate header file:\n"+
									headerPath+"?")){
					HeaderFile headerFile = new HeaderFile(headerPath,guiInfo);
					headerFile.createHeaderFile();
	    	}
    	}
		
	}

	private boolean obtainGuiInfoForHeader(GuiInformation guiInfo) {
		guiInfo.setWdtflag(jCheckBox2.isSelected());
		guiInfo.setJumpToFailSafe(jCheckBox2.isSelected());
		
		guiInfo.setMainClkFreq(Integer.parseInt(jTextField14.getText()));
		guiInfo.setMainClkDiv(Integer.parseInt(jComboBox4.getSelectedItem().toString()));
		guiInfo.setTimertype(jComboBox1.getSelectedIndex());
		guiInfo.setCcrValue(jComboBox2.getSelectedIndex());
		guiInfo.setMinADCDrift(Integer.parseInt(jSpinner1.getValue().toString()));
		guiInfo.setMaxADCDrift(Integer.parseInt(jSpinner2.getValue().toString()));
		guiInfo.setPercentFrequency(Integer.parseInt(jSpinner4.getValue().toString()));
		guiInfo.setAclkFrequency(Integer.parseInt(jTextField15.getText()));
		guiInfo.setAclkDivider(Integer.parseInt(jComboBox6.getSelectedItem().toString()));
		
		if(isHexValue(jTextField2.getText(), 4)){
			guiInfo.setRamStartAddress(jTextField2.getText());
		}else{
			generateErrorMessage("RAM star address is not a 16-bit hex value!");
			return false;
		}
		
		if(isHexValue(jTextField3.getText(), 4)){
			guiInfo.setRamSize(jTextField3.getText());
		}else{
			generateErrorMessage("RAM size is not a 16-bit hex value!");
			return false;
		}
		
		if(isDecValue(jTextField4.getText())){
			guiInfo.setStackSize(jTextField4.getText());
		}else{
			generateErrorMessage("STACK size is not a decimal value!");
			return false;
		}
		
		if(jButton1.isSelected()){
			guiInfo.setMarchTestType(0);
		}else{
			guiInfo.setMarchTestType(1);
		}
		
		if(jCheckBox4.isSelected()){
			guiInfo.setDestructive(true);
			guiInfo.setRamTestBuffer(Integer.parseInt(jSpinner3.getValue().toString()));
		}else{
			guiInfo.setDestructive(false);
		}
		
		if(isHexValue(jTextField16.getText(), 4)){
			guiInfo.setCrcSeed(jTextField16.getText());
		}else{
			generateErrorMessage("CRC initial value is not a valid 16-bit hex value");
			return false;
			
		}
		
		if(isHexValue(jTextField17.getText(), 4)){
			guiInfo.setCheckSumLocation(jTextField17.getText());
		}else{
			generateErrorMessage("Check sum location is not a valid 16-bit hex value");
			return false;
		}
		
		
		HashMap<String, String> codesMap = guiInfo.getTestCodes();
		
		if(isHexValue(jTextField6.getText(), 2)){
			codesMap.put("PC_code", jTextField6.getText());
		}else{
			generateErrorMessage("PC code is not a valid 8-bit hex value");
			return false;
		}
		
		
		if(isHexValue(jTextField7.getText(), 2)){
			codesMap.put("CLOCK_code", jTextField7.getText());
		}else{
			generateErrorMessage("CLOCK code is not a valid 8-bit hex value");
			return false;
		}
		
		if(isHexValue(jTextField8.getText(), 2)){
			codesMap.put("RAM_code", jTextField8.getText());
		}else{
			generateErrorMessage("RAM code is not a valid 8-bit hex value");
			return false;
		}
		
		
		if(isHexValue(jTextField9.getText(), 2)){
			codesMap.put("NV_code", jTextField9.getText());
		}else{
			generateErrorMessage("Non-volatile code is not a valid 8-bit hex value");
			return false;
		}
		
		
		if(isHexValue(jTextField10.getText(), 2)){
			codesMap.put("ADC_code", jTextField10.getText());
		}else{
			generateErrorMessage("ADC code is not a valid 8-bit hex value");
			return false;
		}
		
		if(isHexValue(jTextField11.getText(), 2)){
			codesMap.put("GPIO_code", jTextField11.getText());
		}else{
			generateErrorMessage("GPIO code is not a valid 8-bit hex value");
			return false;
		}
		
		
		if(isHexValue(jTextField12.getText(), 2)){
			codesMap.put("INTERRUPT_code", jTextField12.getText());
		}else{
			generateErrorMessage("INTERRUPT code is not a valid 8-bit hex value");
			return false;
		}
		
		if(isHexValue(jTextField13.getText(), 2)){
			codesMap.put("FAILURE_code", jTextField13.getText());
		}else{
			generateErrorMessage("FAILURE code is not a valid 8-bit hex value");
			return false;
		}
		
		


		

				                      
		
		return true;
		
	}

	private void jCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {                                           
        // TODO add your handling code here:
    }  

    private void jCheckBox5ActionPerformed(java.awt.event.ActionEvent evt) {                                           
        updateCodePanel(jCheckBox5.isSelected());
    }  
    
    private void updateCodePanel(boolean selected) {
    	
    	if(selected==false){
    		jTextField6.setText("0xCD");
    		jTextField7.setText("0xCE");
    		jTextField8.setText("0xCF");
    		jTextField9.setText("0xD0");
    		jTextField10.setText("0xD1");
    		jTextField11.setText("0xD2");
    		jTextField12.setText("0xD3");
    		jTextField13.setText("0x00");
    	}
    	
		jLabel9.setEnabled(!selected);
		jLabel10.setEnabled(!selected);
		jLabel11.setEnabled(!selected);
		jLabel12.setEnabled(!selected);
		jLabel13.setEnabled(!selected);
		jLabel14.setEnabled(!selected);
		jLabel15.setEnabled(!selected);
		jLabel16.setEnabled(!selected);
		jLabel17.setEnabled(!selected);
		jTextField5.setEnabled(!selected);
		jTextField6.setEnabled(!selected);
		jTextField7.setEnabled(!selected);
		jTextField8.setEnabled(!selected);
		jTextField9.setEnabled(!selected);
		jTextField10.setEnabled(!selected);
		jTextField11.setEnabled(!selected);
		jTextField12.setEnabled(!selected);
		jTextField13.setEnabled(!selected);
		jTextField5.setEditable(!selected);
		jTextField6.setEditable(!selected);
		jTextField7.setEditable(!selected);
		jTextField8.setEditable(!selected);
		jTextField9.setEditable(!selected);
		jTextField10.setEditable(!selected);
		jTextField11.setEditable(!selected);
		jTextField12.setEditable(!selected);
		jTextField13.setEditable(!selected);
		
	}

	private void jCheckBox6ActionPerformed(java.awt.event.ActionEvent evt) {                                           
        modifyBrowseOption(jCheckBox6.isSelected(), jTextField18, jButton3);
    } 
    
    private void jCheckBox7ActionPerformed(java.awt.event.ActionEvent evt) {                                           
    	modifyBrowseOption(jCheckBox7.isSelected(), jTextField19, jButton4);
    } 
    
    private void jCheckBox8ActionPerformed(java.awt.event.ActionEvent evt) {                                           
    	modifyBrowseOption(jCheckBox8.isSelected(), jTextField20, jButton5);
    } 
    
    private void jCheckBox9ActionPerformed(java.awt.event.ActionEvent evt) {                                           
    	modifyBrowseOption(jCheckBox9.isSelected(), jTextField21, jButton6);
    } 
    private void jCheckBox10ActionPerformed(java.awt.event.ActionEvent evt) {                                           
    	updateGeneratePanel(jCheckBox10.isSelected());
    } 


    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {                                         
        setFilePath("Location of Memory File#1", jTextField18);
    }                                        

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {                                         
    	setFilePath("Location of Memory File#1", jTextField19);
    }                                        

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {                                         
    	setFilePath("Location of Memory File#1", jTextField20);
    }                                        

    private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {                                         
    	setFilePath("Location of Memory File#1", jTextField21);
    }      
    
    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {                                         
    	if(isHexValue(jTextField16.getText(),4)){
    		if(filePathsAvailable()){
    			if(validFileExtension()){
    				calculteCRCchecksums();
    			}
    			
    		}else{
    			generateErrorMessage("No memory file(s) available for CRC calculation.");
    		}
    		
    		
    	}else{
    		generateErrorMessage("Invalid Initial CRC value: Initial value must be a\n" +
    							 "16-bit hex value (e.g. 0x1880 or 0x0000)");
    	}
    } 
    
    private void jButton8ActionPerformed(ActionEvent evt) {
    	setFilePath("output location CRC checksum file", jTextField26);
    	String filePath = jTextField26.getText();
    	
    	if(filePath.isEmpty()==false){
	    	if(!(filePath.endsWith(".dat") || (filePath.endsWith(".txt")))){
	    		if(jComboBox7.getSelectedIndex()==0){
	    			filePath += ".dat";
	    		}else{
	    			filePath += ".txt";
	    		}
	    		
	    		jTextField26.setText(filePath);
	    	}
    	}
    	
		
	}
    
    private void jButton9ActionPerformed(ActionEvent evt) {
    	
    	String filePath = jTextField26.getText();
    	if(!filePath.isEmpty()){
	    	File crcFile =new File(filePath);
	    
	    	if(crcFile.exists()){
	    		boolean accept = generateApproved("File: " + crcFile.getName() + "\n\n" +
						 "Already exists, do you want to overwrite it?");
	    		if(accept){
	    			generateCRCFile(crcFile);
	    		}
	    	}else{
	    		boolean accept= generateApproved("File: " + crcFile.getAbsolutePath() + "\n\n" +
	    						 "Doesn't exist, do you want to create it?");
	    		if(accept){
	    			try {
						crcFile.createNewFile();
						generateCRCFile(crcFile);
					} catch (IOException e) {
						generateErrorMessage(e.getMessage());
					}
	    			
	    		}
	    	}
    	}else{
    		generateWarnign("Output file path for CRC checksum memory file is empty.\n\n" + 
    						"Please specify a valid path");
    	}
    	
    	
		
	}


	private void jCheckBox4ActionPerformed(java.awt.event.ActionEvent evt) {
        updateNonDestructive(jCheckBox4.isSelected());
    }
	
	private void updateNonDestructive(boolean selected) {
		jLabel7.setEnabled(selected);
		jLabel8.setEnabled(selected);
		jSpinner3.setEnabled(selected);
	}

	private void jComboBox4ActionPerformed(ActionEvent evt) {
		// TODO Auto-generated method stub
		
	}
    
    private void setDirectoryPath(String title, JTextField textField) {
    	JFileChooser fc = new JFileChooser();
    	fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		fc.setSelectedFile(new File(jTextField1.getText()));
		fc.setDialogTitle("Select " + title);
		int returnVal = fc.showOpenDialog(jPanel4);
		if(returnVal == JFileChooser.APPROVE_OPTION){
			textField.setText(fc.getSelectedFile().getAbsolutePath());
		}
	}
    
    private void setFilePath(String title, JTextField textField) {
    	JFileChooser fc = new JFileChooser();
		try {
			fc.setSelectedFile(new File(".").getCanonicalFile());
		} catch (IOException e) {
			e.printStackTrace();
		}
		fc.setDialogTitle("Select " + title);
		int returnVal = fc.showOpenDialog(jPanel4);
		if(returnVal == JFileChooser.APPROVE_OPTION){
			textField.setText(fc.getSelectedFile().getAbsolutePath());
		}
	}
    
    private void modifyBrowseOption(boolean checkFlag, JTextField field, JButton button){
    	if(checkFlag){
        	field.setEditable(true);
        	field.setEnabled(true);
        	button.setEnabled(true);
        }
        else{
        	field.setEditable(false);
        	field.setText("");
        	field.setEnabled(false);
        	button.setEnabled(false);
        }
    	
    	updateCalculateButton();
    	
    	
    }
    
    private void updateCalculateButton(){
    	if(fileAvailable()){
    		jButton7.setEnabled(true);
    	}else{
    		jButton7.setEnabled(false);
    	}
    }
    
    
    private boolean fileAvailable(){
    	return (jCheckBox6.isSelected() || jCheckBox7.isSelected() || jCheckBox8.isSelected() || jCheckBox9.isSelected());
    }
    
    private boolean filePathsAvailable(){
    	if(jTextField18.getText().isEmpty() && jTextField19.getText().isEmpty() &&
    	   jTextField20.getText().isEmpty()	&& jTextField21.getText().isEmpty()){
    		return false;
    	}
    	
    	return true;
    }
    
    private boolean validFileExtension(){
    	
    	if(jCheckBox6.isSelected()){
    		String filePathString = jTextField18.getText();
    		if(!filePathString.isEmpty()){
	    		if(!(filePathString.endsWith(".dat") || filePathString.endsWith(".txt"))){
	    			generateErrorMessage("Invalid file type for Memory File #1.\n\n Supported files: *.dat and *.txt (TI-TXT file)");
	    			return false;
	    		}
	    	}else{
	    		generateErrorMessage("Please specify location of Memory File#1");
	    		return false;
	    		
	    	}
    	}
    	
    	
		if(jCheckBox7.isSelected()){
			String filePathString = jTextField19.getText();
			if(!filePathString.isEmpty()){
	    		if(!(filePathString.endsWith(".dat") || filePathString.endsWith(".txt"))){
	        		generateErrorMessage("Invalid file type for Memory File #2.\n\n Supported files: *.dat and *.txt (TI-TXT file)");
	        		return false;
	        	}
	    	}else{
	    		generateErrorMessage("Please specify path to Memory File#2");
        		return false;
	    		
	    	}
    		
    			
    	}


		if(jCheckBox8.isSelected()){
			String filePathString = jTextField20.getText();
    		if(!filePathString.isEmpty()){
				if(!(filePathString.endsWith(".dat") || filePathString.endsWith(".txt"))){
	        		generateErrorMessage("Invalid file type for Memory File #3.\n\n Supported files: *.dat and *.txt (TI-TXT file)");
	        		return false;
	        	}
    		}else{
	    		generateErrorMessage("Please specify path to Memory File#3");
	    		return false;
	    		
	    	}
			
		}


		if(jCheckBox9.isSelected()){
			String filePathString = jTextField21.getText();
    		if(!filePathString.isEmpty()){
				if(!(filePathString.endsWith(".dat") || filePathString.endsWith(".txt"))){
	        		generateErrorMessage("Invalid file type for Memory File #4.\n\n Supported files: *.dat and *.txt (TI-TXT file)");
	        		return false;
	        	}
    		}else{
	    		generateErrorMessage("Please specify path to Memory File#4");
	    		return false;
	    		
	    	}
		}

    	return true;
    }
    
    private void calculteCRCchecksums() {
		String initialValueString = jTextField16.getText();
		int initialValue = Integer.decode(initialValueString);
		String crc = null;
		
		jTextField22.setText("");
		jTextField23.setText("");
		jTextField24.setText("");
		jTextField25.setText("");
		
    	if(jCheckBox6.isSelected()){
    		String filePathString = jTextField18.getText();
    		try {
				crc= new CRC16CCITT(filePathString,initialValue).calculateCRC();
				crc = zeroPadHexString(crc);
				jTextField22.setText(crc);
			} catch (IOException e) {
				System.err.println("Corrupted Memory File#1!");
			}finally{
				if(jTextField22.getText().isEmpty()){
					generateErrorMessage("Memory File #1 contains multiple memory sections\n"+
							 			 "or file conatins invalid 16-bit hex values");
	    		}
			}    		

    	}
    	
    	if(jCheckBox7.isSelected()){
    		String filePathString = jTextField19.getText();
    		try {
				crc= new CRC16CCITT(filePathString,initialValue).calculateCRC();
				crc = zeroPadHexString(crc);
				jTextField23.setText(crc);
			} catch (IOException e) {
				System.err.println("Corrupted Memory File#2!");
			}finally{
				if(jTextField23.getText().isEmpty()){
					generateErrorMessage("Memory File #2 contains multiple memory sections\n"+
							 			 "or file conatins invalid 16-bit hex values");
	    		}
			} 

    	}

    	if(jCheckBox8.isSelected()){
    		String filePathString = jTextField20.getText();
    		try {
				crc= new CRC16CCITT(filePathString,initialValue).calculateCRC();
				crc = zeroPadHexString(crc);
				jTextField24.setText(crc);
			} catch (IOException e) {
				System.err.println("Corrupted Memory File#3!");
			}finally{
				if(jTextField24.getText().isEmpty()){
					generateErrorMessage("Memory File #3 contains multiple memory sections\n"+
							 			 "or file conatins invalid 16-bit hex values");
	    		}
			} 
    	}


    	if(jCheckBox9.isSelected()){
    		String filePathString = jTextField21.getText();
    		try {
				crc= new CRC16CCITT(filePathString,initialValue).calculateCRC();
				crc = zeroPadHexString(crc);
				jTextField25.setText(crc);
			} catch (IOException e) {
				System.err.println("Corrupted Memory File#4!");
			}finally{
				if(jTextField25.getText().isEmpty()){
					generateErrorMessage("Memory File #4 contains multiple memory sections\n"+
							 			 "or file conatins invalid 16-bit hex values");
	    		}
			} 

    	}
    	
    	if(areCRCavailable()){
    		jCheckBox10.setEnabled(true);
    		jPanel10.setEnabled(true);
    		
    	}
		
	}
    
    private String zeroPadHexString(String crc) {
		int length = crc.length();
		
		if(length < 6){
			String temp = crc.substring(2);
			crc = "0x";
			while(length<6){
				crc += "0";
				length++;
			}
			
			crc += temp;
		}
		
		return crc;
		
	}

	private boolean isHexValue(String value, int size){
    	// Must start with 0x has to be of length "size" and contain valid hex values
    	String HEX_PATTERN = "^0x[A-Fa-f0-9]{"+size+"}$";
    	Pattern pattern = Pattern.compile(HEX_PATTERN);
    	
		if(pattern.matcher(value).matches()){
			return true;
		}
    	    	
    	return false;
    }
    
    
    private boolean isDecValue(String value){
    	// Must start with 0x has to be of length "size" and contain valid hex values
    	
    	String DEC_PATTERN = "[0-9]{"+value.length()+"}";
    	Pattern pattern = Pattern.compile(DEC_PATTERN);
    	
		if(pattern.matcher(value).matches()){
			return true;
		}
    	    	
    	return false;
    }
    
    private boolean generateApproved(String approveMessage){
    	Object[] options = {"Yes","No","Cancel"};

		  int n = JOptionPane.showOptionDialog(jPanel4,
				    approveMessage,
				    "",
				    JOptionPane.YES_NO_CANCEL_OPTION,
				    JOptionPane.QUESTION_MESSAGE,
				    null,
				    options,
				    options[2]);
		
		  switch (n) {
			case 0:
				   return true;
			default:
				break;
		  }
		  
		  return false;
    	
    }
    
    private void generateWarnign(String warningMessage){
    	JOptionPane.showMessageDialog(jPanel4,
				    warningMessage,
				    "Warning",
				    JOptionPane.WARNING_MESSAGE);
    }
    
    private void generateErrorMessage(String errorMessage){
	    JOptionPane.showMessageDialog(jPanel4,
			    errorMessage,
			    "Error",
			    JOptionPane.ERROR_MESSAGE);
    }
    
    private String formatHexString(String value){
    	return value.trim();
    }
    
    private boolean areCRCavailable(){
    	return !(jTextField22.getText().isEmpty() && jTextField23.getText().isEmpty() &&
    			jTextField24.getText().isEmpty() && jTextField25.getText().isEmpty()); 
    }
    
    private void updateGeneratePanel(boolean generationFlag){
    	if(generationFlag){
    		jLabel34.setEnabled(true);
    		jComboBox7.setEnabled(true);
    		jLabel35.setEnabled(true);
    		jTextField26.setEnabled(true);
    		jTextField26.setEditable(true);
    		jButton8.setEnabled(true);
    		jButton9.setEnabled(true);
    	}else{
    		jLabel34.setEnabled(false);
    		jComboBox7.setEnabled(false);
    		jLabel35.setEnabled(false);
    		jTextField26.setEnabled(false);
    		jTextField26.setEditable(false);
    		jTextField26.setText("");
    		jButton8.setEnabled(false);
    		jButton9.setEnabled(false);
    	}
    }
    
    private ArrayList<String> getCRCChecksums(){
    	ArrayList<String> crcChecksums = new ArrayList<String>();
    	if(areCRCavailable()){
    		
    		if(!jTextField22.getText().isEmpty()){
    			crcChecksums.add(jTextField22.getText());
    		}
    		if(!jTextField23.getText().isEmpty()){
    			crcChecksums.add(jTextField23.getText());
    		}
    		if(!jTextField24.getText().isEmpty()){
    			crcChecksums.add(jTextField24.getText());
    		}
    		if(!jTextField25.getText().isEmpty()){
    			crcChecksums.add(jTextField25.getText());
    		}
    	}else{
    		generateErrorMessage("No CRC chesums available");
    	}
    	
    	return crcChecksums;
    	
    }
    
    private void generateCRCFile(File outputFile){
    	
    	int memoryFiletype = -1;
		if(jComboBox7.getSelectedIndex()==0){
			memoryFiletype = 0;
		}else{
			memoryFiletype = 1;
		}
		
		ArrayList<String> crcChecksums = getCRCChecksums();
		
		
		
		String fileType= jComboBox7.getSelectedItem().toString().substring(1);
		String fileName= outputFile.getName();
		if(fileName.endsWith(fileType)){
			String memLocation = jTextField17.getText();
			if(isHexValue(memLocation,4)){
				if(validchecksums(crcChecksums)){
					if(generateApproved("Do you want to generate CRC checksum file?")){
						MemoryFile memoryFile = new MemoryFile(outputFile, memoryFiletype, jTextField17.getText() , crcChecksums);
						memoryFile.createMemoryFile();
					}else{
						generateErrorMessage("Invalid CRC checksum initial memory location");
					}
				}else{
					generateErrorMessage("CRC checksums are not 16-bit hex values.");
				}
			}else{
			generateErrorMessage("Memory file type does not match file extension");
			}
		}
    }
    
    
    
    
    

    private boolean validchecksums(ArrayList<String> crcChecksums) {
    	for(String crcChecksum:crcChecksums){
			if(isHexValue(crcChecksum,4)==false){
				return false;
			}
		}
    	return true;
	}

	/**
     * @param args the command line arguments
     */
    public static void main(final String args[]) {
    	
    	// Check input arguments 
    	if((args.length >= 0) && (args.length<3)){
    		if(args.length==2){
    			if(args[0].toLowerCase().contentEquals("-dir")){
    				
    				try {
						System.out.println("Verifying " + new File(args[1]).getCanonicalPath() + " is a valid directory ...");
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						System.err.println(e1.getMessage());
					}
    				
    				try {
						if(new File(args[1]).getCanonicalFile().isDirectory()){
							System.out.println(new File(args[1]).getCanonicalPath()+" is a valid diretory!");
							System.out.println("Input parameter validation completed. Starting IEC60730 Config Tool GUI ...");
						}else{
							System.err.println("ERROR: \"" + new File(args[1]).getCanonicalPath() + "\" is not a valid directory!");
							System.exit(0);
						}
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
    				
    			}else{
    				System.err.println("ERROR: \"" + args[0] + "\" is not a valid argument!");
    	    		System.exit(0);
    			}
    		}else if (args.length ==0){
    			System.out.println("Using default directory: "+new File(".").getAbsolutePath());
    		}else{
    			System.err.println("ERROR: invalid number of arguments.");
	    		System.exit(0);
    		}

    	}else{
    		System.err.println("ERROR: Invalid number of arguments! Exiting application.");
    		System.exit(0);
    	}
    	
    	
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Iec60730ConfigUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Iec60730ConfigUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Iec60730ConfigUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Iec60730ConfigUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }

        /*
         * Create and display the form
         */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new Iec60730ConfigUI(args).setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify
    private javax.swing.JMenuItem fileMenuItem;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JButton jButton9;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox10;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JCheckBox jCheckBox3;
    private javax.swing.JCheckBox jCheckBox4;
    private javax.swing.JCheckBox jCheckBox5;
    private javax.swing.JCheckBox jCheckBox6;
    private javax.swing.JCheckBox jCheckBox7;
    private javax.swing.JCheckBox jCheckBox8;
    private javax.swing.JCheckBox jCheckBox9;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JComboBox jComboBox2;
    private javax.swing.JComboBox jComboBox3;
    private javax.swing.JComboBox jComboBox4;
    private javax.swing.JComboBox jComboBox5;
    private javax.swing.JComboBox jComboBox6;
    private javax.swing.JComboBox jComboBox7;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel28;
    private javax.swing.JLabel jLabel29;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel30;
    private javax.swing.JLabel jLabel31;
    private javax.swing.JLabel jLabel32;
    private javax.swing.JLabel jLabel33;
    private javax.swing.JLabel jLabel34;
    private javax.swing.JLabel jLabel35;
    private javax.swing.JLabel jLabel36;
    private javax.swing.JLabel jLabel37;
    private javax.swing.JLabel jLabel38;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton2;
    private javax.swing.JSpinner jSpinner1;
    private javax.swing.JSpinner jSpinner2;
    private javax.swing.JSpinner jSpinner3;
    private javax.swing.JSpinner jSpinner4;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField10;
    private javax.swing.JTextField jTextField11;
    private javax.swing.JTextField jTextField12;
    private javax.swing.JTextField jTextField13;
    private javax.swing.JTextField jTextField14;
    private javax.swing.JTextField jTextField15;
    private javax.swing.JTextField jTextField16;
    private javax.swing.JTextField jTextField17;
    private javax.swing.JTextField jTextField18;
    private javax.swing.JTextField jTextField19;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTextField jTextField20;
    private javax.swing.JTextField jTextField21;
    private javax.swing.JTextField jTextField22;
    private javax.swing.JTextField jTextField23;
    private javax.swing.JTextField jTextField24;
    private javax.swing.JTextField jTextField25;
    private javax.swing.JTextField jTextField26;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JTextField jTextField4;
    private javax.swing.JTextField jTextField5;
    private javax.swing.JTextField jTextField6;
    private javax.swing.JTextField jTextField7;
    private javax.swing.JTextField jTextField8;
    private javax.swing.JTextField jTextField9;
    private javax.swing.JMenu mainMenu;
    private javax.swing.JMenuBar mainMenuBar;
   
    
    // End of variables declaration
}

